//+------------------------------------------------------------------+
//|   SMI Alerts & Arrows                                            |
//|   Based On William Blau & Mladen SMI                             |
//|                                                                  |
//|   Copyright  2014 / airquest@hotmail.com                        |
//|                                                                  |
//|   http://smart-trading.world-record.ch                           |
//+------------------------------------------------------------------+


   #property copyright "Copyright  2014 // airquest // smart-trading.world-record.ch"
   #property link      "http://smart-trading.world-record.ch"


//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum  100
#property indicator_buffers 8
#property indicator_color1  White
#property indicator_width1  1
#property indicator_color2  Yellow
#property indicator_width2  1
#property indicator_color3  Red
#property indicator_width3  2
#property indicator_color4  Red
#property indicator_width4  1
#property indicator_color5  Lime
#property indicator_width5  2
#property indicator_color6  Lime
#property indicator_width6  1
#property indicator_color7  Lime
#property indicator_width7  3
#property indicator_color8  Red
#property indicator_width8  3



extern int     Length      = 5;
extern int     Smooth1     = 3;
extern int     Smooth2     = 3;
extern int     Signal      = 3;
extern int     Price       = PRICE_CLOSE;
extern double  OverBought1 =  48.2;
extern double  OverSold1   = -48.2;
extern double  OverBought2 =    60;
extern double  OverSold2   =   -60;
extern bool    ColorOnOBOS1_NotOBOS2       = True;
extern string  ___________ChartWindowArrows___________ = "-------- Chart Window Arrows --------";
extern bool    ShowArrowsOnChartWindow     = True;
extern bool    CWArrowsOnlyOnOBOSCrosses   = True;
extern bool    CWTakeOBOSLevel1_Not2       = True;
extern double  CWArrowDisplacement         = 1.0;
extern string  ___________SeparateWindowArrows___________ = "-------- Separate Window Arrows --------";
extern bool    ShowArrowsOnSeparateWindow  = True;
extern bool    SWArrowsOnlyOnOBOSCrosses   = True;
extern bool    SWTakeOBOSLevel1_Not2       = True;
extern double  SWArrowDisplacement         = 20.0;
extern color   ArrowsUpColor               = Lime;
extern color   ArrowsDnColor               = Red;
extern int     ArrowsUpCode                = 233;
extern int     ArrowsDnCode                = 234;
extern int     ArrowsWidth                 = 3;
extern string  ArrowsIdentifier            = "SMI Arrows";
extern string  ___________Alerts___________ = "-------- Alerts --------";
extern bool    AlertsOn                    = True;
extern bool    AlertsOnCurrent             = False;
extern bool    AlertsOnlyOnOBOSCrosses     = True;
extern bool    AlertsOnOBOSLevel1_Not2     = True;
extern bool    AlertsMessage               = True;
extern bool    AlertsEmail                 = False;
extern bool    AlertsSound                 = False;


double smo[];
double sms[];
double tBuffer[][6];
double smoUa[];
double smoUb[];
double smoDa[];
double smoDb[];
double state[];
double trend[];
double BuySignal[];
double SellSignal[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,smo);        SetIndexLabel(0,"Stochastic Momentum");
   SetIndexBuffer(1,sms);        SetIndexLabel(1,"Stochastic Momentum Signal");
   SetIndexBuffer(2,smoUa);      SetIndexLabel(2,NULL);
   SetIndexBuffer(3,smoUb);      SetIndexLabel(3,NULL);
   SetIndexBuffer(4,smoDa);      SetIndexLabel(4,NULL);
   SetIndexBuffer(5,smoDb);      SetIndexLabel(5,NULL);
   SetIndexBuffer(6,BuySignal);  SetIndexStyle(6,DRAW_ARROW);  SetIndexArrow(6,233);
   SetIndexBuffer(7,SellSignal); SetIndexStyle(7,DRAW_ARROW);  SetIndexArrow(7,234);
   SetIndexBuffer(8,state);      SetIndexLabel(8,NULL);
   SetIndexBuffer(9,trend);      SetIndexLabel(9,NULL);
   
         SetLevelValue(0,OverBought1);
         SetLevelValue(1,OverSold1);
         SetLevelValue(2,OverBought2);
         SetLevelValue(3,OverSold2);

   string PriceType;
      switch(Price)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
         case PRICE_OPEN:     PriceType = "Open";     break;  // 1
         case PRICE_HIGH:     PriceType = "High";     break;  // 2
         case PRICE_LOW:      PriceType = "Low";      break;  // 3
         case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
         case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
      }

   Length  = MathMax(Length ,1);
   Smooth1 = MathMax(Smooth1,1);
   Smooth2 = MathMax(Smooth2,1);
   IndicatorShortName (" Stochastic Momentum ("+Length+","+Smooth1+","+Smooth2+","+PriceType+")");
   return(0);
}
int deinit()
{
   deleteArrows();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#define ema10 0
#define ema11 1
#define ema12 2
#define ema20 3
#define ema21 4
#define ema22 5

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
                 if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

         double alpha1 = 2.0 /(1.0+Smooth1);
         double alpha2 = 2.0 /(1.0+Smooth2);
         double alphas = 2.0 /(1.0+Signal);

   for(i=limit,r=Bars-i-1; i >= 0; i--,r++)
   {
      double hh = High[iHighest(NULL,0,MODE_HIGH,Length,i)];
      double ll =  Low[ iLowest(NULL,0,MODE_LOW ,Length,i)];
      double pr = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         tBuffer[r][ema10] = pr - 0.5*(hh+ll);
         tBuffer[r][ema20] =           hh-ll;
         if (i>=Bars-3)
         {
            tBuffer[r][ema11] = tBuffer[r][ema10];
            tBuffer[r][ema12] = tBuffer[r][ema10];
            tBuffer[r][ema21] = tBuffer[r][ema20];
            tBuffer[r][ema22] = tBuffer[r][ema20];
            continue;
         }
      
      tBuffer[r][ema11] = tBuffer[r-1][ema11] + alpha1*(tBuffer[r][ema10]-tBuffer[r-1][ema11]);
      tBuffer[r][ema12] = tBuffer[r-1][ema12] + alpha2*(tBuffer[r][ema11]-tBuffer[r-1][ema12]);
      tBuffer[r][ema21] = tBuffer[r-1][ema21] + alpha1*(tBuffer[r][ema20]-tBuffer[r-1][ema21]);
      tBuffer[r][ema22] = tBuffer[r-1][ema22] + alpha2*(tBuffer[r][ema21]-tBuffer[r-1][ema22]);

         smo[i] = 100.00 * tBuffer[r][ema12] / (0.5 * tBuffer[r][ema22]);
         if (Signal>1)
            sms[i] = sms[i+1]+alphas*(smo[i]-sms[i+1]);
   }
   
      for(i=limit; i>=0; i--)
      {
         smoUa[i] = EMPTY_VALUE;
         smoUb[i] = EMPTY_VALUE;
         smoDa[i] = EMPTY_VALUE;
         smoDb[i] = EMPTY_VALUE;
         state[i] = state[i+1];

            if(ColorOnOBOS1_NotOBOS2)
            {
               if (smo[i] > OverBought1) state[i] =  1;
               if (smo[i] < OverSold1)   state[i] = -1;
               if (smo[i] < OverBought1 && smo[i] > OverSold1) state[i] =  0;
               if (state[i] ==  1) PlotPoint(i,smoUa,smoUb,smo);
               if (state[i] == -1) PlotPoint(i,smoDa,smoDb,smo);
            }
            else
            {
               if (smo[i] > OverBought2) state[i] =  1;
               if (smo[i] < OverSold2)   state[i] = -1;
               if (smo[i] < OverBought2 && smo[i] > OverSold2) state[i] =  0;
               if (state[i] ==  1) PlotPoint(i,smoUa,smoUb,smo);
               if (state[i] == -1) PlotPoint(i,smoDa,smoDb,smo);
            }
         
         BuySignal[i]  = EMPTY_VALUE;
         SellSignal[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];

         if (smo[i] >  sms[i]) trend[i] =  1;
         if (smo[i] <  sms[i]) trend[i] = -1;
         if (smo[i] == sms[i]) trend[i] =  0;

         if(ShowArrowsOnSeparateWindow)
         {
            if(SWArrowsOnlyOnOBOSCrosses)
            {
               if(SWTakeOBOSLevel1_Not2)  if ((trend[i] != trend[i+1]) && (trend[i] ==  1) && (smo[i] < OverSold1   || (smo[i+1] < OverSold1   && sms[i+1] < OverSold1)))   BuySignal[i]  = smo[i] - SWArrowDisplacement;
               if(SWTakeOBOSLevel1_Not2)  if ((trend[i] != trend[i+1]) && (trend[i] == -1) && (smo[i] > OverBought1 || (smo[i+1] > OverBought1 && sms[i+1] > OverBought1))) SellSignal[i] = smo[i] + SWArrowDisplacement;
               if(!SWTakeOBOSLevel1_Not2) if ((trend[i] != trend[i+1]) && (trend[i] ==  1) && (smo[i] < OverSold2   || (smo[i+1] < OverSold2   && sms[i+1] < OverSold2)))   BuySignal[i]  = smo[i] - SWArrowDisplacement;
               if(!SWTakeOBOSLevel1_Not2) if ((trend[i] != trend[i+1]) && (trend[i] == -1) && (smo[i] > OverBought2 || (smo[i+1] > OverBought2 && sms[i+1] > OverBought2))) SellSignal[i] = smo[i] + SWArrowDisplacement;
            }
            else
            {
               if ((trend[i] != trend[i+1]) && (trend[i] ==  1)) BuySignal[i]  = smo[i] - SWArrowDisplacement;
               if ((trend[i] != trend[i+1]) && (trend[i] == -1)) SellSignal[i] = smo[i] + SWArrowDisplacement;
            }
         }
         if(ShowArrowsOnChartWindow)
         {
            manageArrow(i);
         }

         if (AlertsOn)
         {
            if (AlertsOnCurrent)
               int whichBar = 0;
            else   whichBar = 1;
            if (trend[whichBar] != trend[whichBar+1])
            {
               if(AlertsOnlyOnOBOSCrosses)
               {
                  if (AlertsOnOBOSLevel1_Not2  && trend[whichBar] ==  1 && (smo[whichBar] < OverSold1   || (smo[whichBar+1] < OverSold1   && sms[whichBar+1] < OverSold1)))   doAlert(whichBar,"MA Cross Up");
                  if (AlertsOnOBOSLevel1_Not2  && trend[whichBar] == -1 && (smo[whichBar] > OverBought1 || (smo[whichBar+1] > OverBought1 && sms[whichBar+1] > OverBought1))) doAlert(whichBar,"MA Cross Down");
                  if (!AlertsOnOBOSLevel1_Not2 && trend[whichBar] ==  1 && (smo[whichBar] < OverSold2   || (smo[whichBar+1] < OverSold2   && sms[whichBar+1] < OverSold2)))   doAlert(whichBar,"MA Cross Up");
                  if (!AlertsOnOBOSLevel1_Not2 && trend[whichBar] == -1 && (smo[whichBar] > OverBought2 || (smo[whichBar+1] > OverBought2 && sms[whichBar+1] > OverBought2))) doAlert(whichBar,"MA Cross Down");
               }
               else
               {
                  if (trend[whichBar] ==  1) doAlert(whichBar,"MA Cross Up");
                  if (trend[whichBar] == -1) doAlert(whichBar,"MA Cross Down");
               }         
            }
         }
      }
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}


void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


void manageArrow(int i)
{
      deleteArrow(Time[i]);
      if(CWArrowsOnlyOnOBOSCrosses)
      {
         if(CWTakeOBOSLevel1_Not2)  if ((trend[i] != trend[i+1]) && (trend[i] ==  1) && (smo[i] < OverSold1   || (smo[i+1] < OverSold1   && sms[i+1] < OverSold1)))   drawArrow(i,ArrowsUpColor,ArrowsUpCode,ArrowsWidth,false);
         if(CWTakeOBOSLevel1_Not2)  if ((trend[i] != trend[i+1]) && (trend[i] == -1) && (smo[i] > OverBought1 || (smo[i+1] > OverBought1 && sms[i+1] > OverBought1))) drawArrow(i,ArrowsDnColor,ArrowsDnCode,ArrowsWidth,true);
         if(!CWTakeOBOSLevel1_Not2) if ((trend[i] != trend[i+1]) && (trend[i] ==  1) && (smo[i] < OverSold2   || (smo[i+1] < OverSold2   && sms[i+1] < OverSold2)))   drawArrow(i,ArrowsUpColor,ArrowsUpCode,ArrowsWidth,false);
         if(!CWTakeOBOSLevel1_Not2) if ((trend[i] != trend[i+1]) && (trend[i] == -1) && (smo[i] > OverBought2 || (smo[i+1] > OverBought2 && sms[i+1] > OverBought2))) drawArrow(i,ArrowsDnColor,ArrowsDnCode,ArrowsWidth,true);
      }
      else
      {
         if ((trend[i] != trend[i+1]) && (trend[i] ==  1)) drawArrow(i,ArrowsUpColor,ArrowsUpCode,ArrowsWidth,false);
         if ((trend[i] != trend[i+1]) && (trend[i] == -1)) drawArrow(i,ArrowsDnColor,ArrowsDnCode,ArrowsWidth,true);
      }
}


void drawArrow(int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = ArrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,100,i) * CWArrowDisplacement;
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}


void deleteArrows()
{
   string lookFor       = ArrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = ArrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="Nothing";
   static datetime previousTime;
   string message;

   if (previousAlert != doWhat || previousTime != Time[forBar])
   {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",Symbol()," ",Period()," SMI ",doWhat);
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(StringConcatenate(Symbol(),"SMI "),message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}